package com.huigou.bpmc.chart.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import com.huigou.bpmc.chart.domain.model.ProcessNodeFunction;

/**
 * Repository
 * 
 * @author
 * @date 2018-01-29 09:47
 */
public interface ProcessNodeFunctionRepository extends JpaRepository<ProcessNodeFunction, String> {
    List<ProcessNodeFunction> findByBusinessProcessIdOrderBySequenceAsc(String businessProcessId);

    List<ProcessNodeFunction> findByViewIdOrderBySequenceAsc(String viewId);

    @Modifying
    @Query("delete ProcessNodeFunction a where a.businessProcessId = ?1")
    void deleteByProcessId(String businessProcessId);

    @Modifying
    @Query("delete ProcessNodeFunction a where a.viewId = ?1")
    void deleteByViewId(String viewId);
}
