package com.huigou.bpmc.chart.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import com.huigou.bpmc.chart.domain.model.ProcessNodeLine;

/**
 * Repository
 * 
 * @author xx
 * @date 2017-04-17 09:23
 */
public interface ProcessNodeLineRepository extends JpaRepository<ProcessNodeLine, String> {
    List<ProcessNodeLine> findByBusinessProcessId(String businessProcessId);

    @Modifying
    @Query("delete ProcessNodeLine a where a.businessProcessId = ?1")
    void deleteLineByProcessId(String businessProcessId);

    @Modifying
    @Query("delete ProcessNodeLine a where a.fromNode = ?1 or a.toNode= ?1")
    void deleteLineByNode(String id);
}
