package com.huigou.bpmc.chart.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import com.huigou.bpmc.chart.domain.model.ProcessNodeTemp;

/**
 * Repository
 * 
 * @author xx
 * @date 2017-04-17 09:23
 */
public interface ProcessNodeTempRepository extends JpaRepository<ProcessNodeTemp, String> {
    List<ProcessNodeTemp> findByBusinessProcessId(String businessProcessId);

    List<ProcessNodeTemp> findOneByBusinessProcessIdAndViewId(String businessProcessId, String viewId);

    @Modifying
    @Query("delete ProcessNodeTemp a where a.businessProcessId = ?1")
    void deleteByProcessId(String businessProcessId);

}
