package com.huigou.bpmc.common;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Service;

import com.huigou.bpmc.chart.application.FlowChartPermissionsApplication;
import com.huigou.bpmc.chart.domain.model.ProcessNodeFunction;
import com.huigou.bpmc.function.application.FunctionGroupPermissionsApplication;
import com.huigou.bpmc.function.domain.model.FunctionsDetailsDto;

/**
 * 不进行权限校验 所有输入都具有权限
 * 
 * @author xiexin
 */
@Service("bpmAllPermissionsApplication")
public class BpmAllPermissionsApplicationImpl implements FlowChartPermissionsApplication, FunctionGroupPermissionsApplication {

    @Override
    public List<ProcessNodeFunction> checkProcessNodeFunction(List<ProcessNodeFunction> nodeFunctions) {
        List<ProcessNodeFunction> objs = new ArrayList<>(nodeFunctions.size());
        if (nodeFunctions == null || nodeFunctions.size() == 0) {
            return objs;
        }
        for (ProcessNodeFunction fun : nodeFunctions) {
            fun.setIsFunction(1);
            objs.add(fun);
        }
        return objs;
    }

    @Override
    public List<FunctionsDetailsDto> checkFunctions(List<FunctionsDetailsDto> datas) {
        List<FunctionsDetailsDto> objs = new ArrayList<>(datas.size());
        if (datas == null || datas.size() == 0) {
            return objs;
        }
        for (FunctionsDetailsDto fun : datas) {
            fun.setHasPermission(true);
            objs.add(fun);
        }
        return objs;
    }

}
