package com.huigou.bpmc.function.application;

import java.util.List;
import java.util.Map;

import com.huigou.bpmc.function.domain.model.Functions;
import com.huigou.bpmc.function.domain.model.FunctionsDetails;
import com.huigou.bpmc.function.domain.model.FunctionsGroup;
import com.huigou.bpmc.function.domain.model.FunctionsGroupDto;
import com.huigou.bpmc.function.domain.query.FunctionsDetailsQueryRequest;
import com.huigou.bpmc.function.domain.query.FunctionsGroupQueryRequest;
import com.huigou.bpmc.function.domain.query.FunctionsQueryRequest;

/**
 * 业务功能分组管理
 * 
 * @author
 * @date 2018-03-28 11:16
 */
public interface BizFunctionApplication {
    /**
     * 查询文件
     */
    String QUERY_XML_FILE_PATH = "config/bpmc/bizFunction.xml";

    Map<String, String> getGroupColorMap();

    Map<String, String> getFuncColorMap();

    /**
     * 保存 业务功能
     * 
     * @author
     * @param params
     */
    String saveFunctions(Functions functions);

    /**
     * 加载 业务功能
     * 
     * @author
     * @return SDO
     */
    Functions loadFunctions(String id);

    /**
     * 删除 业务功能
     * 
     * @author
     */
    void deleteFunctions(String id);

    /**
     * 查询 业务功能
     * 
     * @author
     * @return SDO
     */
    Map<String, Object> slicedQueryFunctions(FunctionsQueryRequest queryRequest);

    /**
     * 保存 业务功能分组
     * 
     * @author
     * @param params
     */
    String saveFunctionsGroup(FunctionsGroup functionsGroup);

    /**
     * 加载 业务功能分组
     * 
     * @author
     * @return SDO
     */
    FunctionsGroup loadFunctionsGroup(String id);

    /**
     * 删除 业务功能分组
     * 
     * @author
     */
    void deleteFunctionsGroup(List<String> ids);

    /**
     * 查询 业务功能分组
     * 
     * @author
     * @return SDO
     */
    Map<String, Object> queryFunctionsGroup(FunctionsGroupQueryRequest queryRequest);

    /**
     * 更新分组排序号
     * 
     * @param map
     */
    void updateFunctionsGroupSequence(Map<String, Integer> map);

    /**
     * 保存 业务功能对应连接
     * 
     * @author
     * @param params
     */
    String saveFunctionsDetails(FunctionsDetails functionsDetails);

    /**
     * 加载 业务功能对应连接
     * 
     * @author
     * @return SDO
     */
    FunctionsDetails loadFunctionsDetails(String id);

    /**
     * 删除 业务功能对应连接
     * 
     * @author
     */
    void deleteFunctionsDetails(List<String> ids);

    /**
     * 查询 业务功能对应连接
     * 
     * @author
     * @return SDO
     */
    Map<String, Object> queryFunctionsDetails(FunctionsDetailsQueryRequest queryRequest);

    /**
     * 修改方法排序号
     * 
     * @param map
     */
    void updateFunctionsDetailsSequence(Map<String, Integer> map);

    /**
     * 移动功能
     * 
     * @param ids
     * @param groupId
     */
    void updateFunctionsDetailsGroup(List<String> ids, String groupId);

    /**
     * 批量修改颜色
     * 
     * @param ids
     * @param color
     */
    void updateFunctionsDetailsColor(List<String> ids, String color);

    List<FunctionsGroupDto> queryFunctionsGroup(String code);

}
