package com.huigou.bpmc.process.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import com.huigou.bpmc.process.domain.model.BusinessProcess;

/**
 * Repository
 *
 * @author
 * @date 2017-04-07 14:00
 */
public interface BusinessProcessRepository extends JpaRepository<BusinessProcess, String> {

    @Query(value = "select max(b.sequence) from BusinessProcess b where b.parentId = :parentId")
    Integer getNextSequence(@Param("parentId") String parentId);

    Integer countByParentId(String parentId);

    List<BusinessProcess> findByParentIdOrderBySequenceAsc(String parentId);

    List<BusinessProcess> findByCode(String code);
}
